package k4unl.minecraft.k4lib.lib;

import com.mojang.authlib.GameProfile;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.util.math.Vec3d;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.world.World;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fml.common.FMLCommonHandler;

import java.util.List;

public class Functions {
    public static List mergeList(List l1, List l2){
        for (Object object : l1) {
            if(!l2.contains(object)){
                l2.add(object);
            }
        }
        return l2;
    }

    public static boolean isInString(String oreName, String[] list){
        boolean ret = false;
        for(int i = 0; i < list.length; i++){
            ret = ret || (oreName.substring(0, list[i].length()).equals(list[i]));
        }
        return ret;
    }

    public static boolean isPlayerOpped(GameProfile player){
        if(FMLCommonHandler.instance().getMinecraftServerInstance().func_184103_al().func_152603_m().func_152685_a().length > 0) {
            for (String name : FMLCommonHandler.instance().getMinecraftServerInstance().func_184103_al().func_152606_n()) {
                if (name.toLowerCase().equals(player.getName().toLowerCase())) {
                    return true;
                }
            }
            return false;
        }
        return true;
    }

    public static boolean isPlayerOpped(String player){
        if(FMLCommonHandler.instance().getMinecraftServerInstance().func_184103_al().func_152603_m().func_152685_a().length > 0) {
            for (String name : FMLCommonHandler.instance().getMinecraftServerInstance().func_184103_al().func_152606_n()) {
                if (name.toLowerCase().equals(player.toLowerCase())) {
                    return true;
                }
            }
            return false;
        }
        return true;
    }

    public static void sendChatMessageServerWide(World world, TextComponentString message){
        for (EntityPlayer player : (List<EntityPlayer>) world.field_73010_i) {
            player.func_145747_a(message);
        }
    }

    public static RayTraceResult getEntityLookedObject(EntityLivingBase entity, float maxDistance){
        Vec3d entityVec = new Vec3d(entity.field_70165_t, entity.field_70163_u + entity.func_70047_e() - entity.func_70033_W() - (entity.func_70093_af() ? 0.08 : 0), entity.field_70161_v);
        Vec3d entityLookVec = entity.func_70676_i(1.0F);
        Vec3d maxDistVec = entityVec.func_72441_c(entityLookVec.field_72450_a * maxDistance, entityLookVec.field_72448_b * maxDistance, entityLookVec.field_72449_c * maxDistance);
        return entity.field_70170_p.func_72933_a(entityVec, maxDistVec);
    }

    public static Location getEntityLookedBlock(EntityLivingBase entity, float maxDistance){
        RayTraceResult hit = getEntityLookedObject(entity, maxDistance);
        if(hit == null || hit.field_72313_a != RayTraceResult.Type.BLOCK) {
            return null;
        }
        return new Location(hit.func_178782_a().func_177958_n(), hit.func_178782_a().func_177956_o(), hit.func_178782_a().func_177952_p());
    }

    public static boolean isInDev() {

        return Boolean.parseBoolean(System.getProperty("k4lib.dev", "false"));
    }

    /**
     * I copied this code from OpenModsLib!
     * Be warned, minecraft doesn't update experienceTotal properly, so we have
     * to do this.
     *
     * @param player
     * @return
     */
    public static int getPlayerXP(EntityPlayer player) {
        return (int)(getExperienceForLevel(player.field_71068_ca) + (player.field_71106_cc * player.func_71050_bK()));
    }

    public static void addPlayerXP(EntityPlayer player, int amount) {
        int experience = getPlayerXP(player) + amount;
        player.field_71067_cb = experience;
        player.field_71068_ca = getLevelForExperience(experience);
        int expForLevel = getExperienceForLevel(player.field_71068_ca);
        player.field_71106_cc = (float)(experience - expForLevel) / (float)player.func_71050_bK();
    }

    public static int getExperienceForLevel(int level) {
        if (level == 0) { return 0; }
        if (level > 0 && level < 16) {
            return level * 17;
        } else if (level > 15 && level < 31) {
            return (int)(1.5 * Math.pow(level, 2) - 29.5 * level + 360);
        } else {
            return (int)(3.5 * Math.pow(level, 2) - 151.5 * level + 2220);
        }
    }

    public static int getXpToNextLevel(int level) {
        int levelXP = getLevelForExperience(level);
        int nextXP = getExperienceForLevel(level + 1);
        return nextXP - levelXP;
    }

    public static int getLevelForExperience(int experience) {
        int i = 0;
        while (getExperienceForLevel(i) <= experience) {
            i++;
        }
        return i - 1;
    }

    public static TextureAtlasSprite getFluidIcon(Fluid fluid) {
        return Minecraft.func_71410_x().func_147117_R().getTextureExtry(fluid.getFlowing().toString());
    }

}
